#if defined _vip_additional_weapon_included
	#endinput
#endif
#define _vip_additional_weapon_included

enum AdditionalWeaponHookType
{
	//	Игрок поднимает дополнительное основное оружие.
	AWHook_OnAdditionalWeaponPickup,
	AWHook_OnAdditionalWeaponPickupPost,
	
	//	Игрок меняет основное оружие на дополнительное.
	AWHook_OnAdditionalWeaponSwitch,
	AWHook_OnAdditionalWeaponSwitchPost
}

typeset AdditionalWeaponCB
{
	//	AWHook_OnAdditionalWeaponPickup
	function Action (int client, int weapon_index);
	
	//	AWHook_OnAdditionalWeaponPickupPost
	function void (int client, int weapon_index);
	
	//	AWHook_OnAdditionalWeaponSwitch
	function Action (int client, int from_weapon_index, int to_weapon_index);
	
	//	AWHook_OnAdditionalWeaponSwitchPost
	function void (int client, int from_weapon_index, int to_weapon_index);
}

native void AdditionalWeaponHook(AdditionalWeaponHookType type, AdditionalWeaponCB callback);
native void AdditionalWeaponUnhook(AdditionalWeaponHookType type, AdditionalWeaponCB callback);

/**
 *	Получить   дополнительное основное оружие.
 *
 *	@note					Дополнительным оружием считается то, которое НЕ в руках у игрока в данный момент.
 *	@return					Индекс оружия, или 0, если его нет/игрок мёртв.
 */
native int  GetClientAdditionalWeapon(int client);

/**
 *	Установить дополнительное основное оружие.
 *
 *	@note					Если у игрока уже есть дополнительное оружие, то оно упадёт на землю.
 *
 *	@param client			Живой игрок, имеющий доступ к VIP функции "additional_weapon".
 *	@param weapon_index		Индекс оружия, лежащего НА ЗЕМЛЕ.
 *
 *	@return					true, если удалось установить.
 */
native bool SetClientAdditionalWeapon(int client, int weapon_index);

public SharedPlugin __pl_AdditionalWeaponVar = 
{
	name = "VipAdditionalWeaponLib",	/* Имя библиотеки */
	file = "ws_vip/additional_weapon.smx",
	required = 0						/* Не требуется, т.к. включается с задержкой (позже обычных .smx). */
};

public void __pl_AdditionalWeaponVar_SetNTVOptional()
{
	MarkNativeAsOptional("AdditionalWeaponHook");
	MarkNativeAsOptional("AdditionalWeaponUnhook");
	
	MarkNativeAsOptional("GetClientAdditionalWeapon");
	MarkNativeAsOptional("SetClientAdditionalWeapon");
}

/* 

/////

// https://world-source.ru/vip_modules/additional_weapon.zip
#include <vip_additional_weapon>

bool g_bAdditionalWeaponLib = false;

public void OnLibraryAdded(const char[] name) {
	OnLib(name, true );
}

public void OnLibraryRemoved(const char[] name) {
	OnLib(name, false);
}

static void OnLib(const char[] name, bool bLib) {
	if ((g_bAdditionalWeaponLib != bLib) && !strcmp(name, "VipAdditionalWeaponLib")) {
		if ((g_bAdditionalWeaponLib = bLib)) {
			//	Lib on.
			
		}
		else{
			//	Lib off.
		}
	}
}

/////

*/